VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cDriveInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private lMaxRSpeed As Long
Private lCurrRSpeed As Long
Private bReadCDR As Boolean
Private bReadCDRW As Boolean
Private bReadDVDR As Boolean
Private bReadDVDROM As Boolean
Private bReadDVDRAM As Boolean
Private bReadSubs As Boolean
Private bReadSubsCorr As Boolean
Private bReadSubsLeadIn As Boolean
Private bReadC2Pointers As Boolean
Private bReadISRC As Boolean
Private bReadUPC As Boolean
Private bReadBC As Boolean

Private lMaxWSpeed As Long
Private lCurrWSpeed As Long
Private bWriteCDR As Boolean
Private bWriteCDRW As Boolean
Private bWriteDVDR As Boolean
Private bWriteDVDRAM As Boolean
Private bWriteTestMode As Boolean
Private bBURNProof As Boolean
Private lBufferSize As Long

Private bMSession As Boolean
Private bMode2Form1 As Boolean
Private bMode2Form2 As Boolean

Private bAnalogAudio As Boolean
Private bCDDARawRead As Boolean
Private bNoJitter As Boolean

Private bLockMedia As Boolean
Private iLoadMech As e_LoadingMechanism

Private bRaw96 As Boolean
Private bRaw16 As Boolean
Private bSao As Boolean
Private bTao As Boolean
Private bRaw96Test As Boolean
Private bRaw16Test As Boolean
Private bSaoTest As Boolean
Private bTaoTest As Boolean

Private iInterface As e_Interfaces

Property Let ReadCDR(ByVal bVal As Boolean)
    bReadCDR = bVal
End Property

Property Get ReadCDR() As Boolean
    ReadCDR = bReadCDR
End Property

Property Let ReadCDRW(ByVal bVal As Boolean)
    bReadCDRW = bVal
End Property

Property Get ReadCDRW() As Boolean
    ReadCDRW = bReadCDRW
End Property

Property Let ReadDVDR(ByVal bVal As Boolean)
    bReadDVDR = bVal
End Property

Property Get ReadDVDR() As Boolean
    ReadDVDR = bReadDVDR
End Property

Property Let ReadDVDROM(ByVal bVal As Boolean)
    bReadDVDROM = bVal
End Property

Property Get ReadDVDROM() As Boolean
    ReadDVDROM = bReadDVDROM
End Property

Property Let ReadDVDRAM(ByVal bVal As Boolean)
    bReadDVDRAM = bVal
End Property

Property Get ReadDVDRAM() As Boolean
    ReadDVDRAM = bReadDVDRAM
End Property

Property Let WriteCDR(ByVal bVal As Boolean)
    bWriteCDR = bVal
End Property

Property Get WriteCDR() As Boolean
    WriteCDR = bWriteCDR
End Property

Property Let WriteCDRW(ByVal bVal As Boolean)
    bWriteCDRW = bVal
End Property

Property Get WriteCDRW() As Boolean
    WriteCDRW = bWriteCDRW
End Property

Property Let WriteDVDR(ByVal bVal As Boolean)
    bWriteDVDR = bVal
End Property

Property Get WriteDVDR() As Boolean
    WriteDVDR = bWriteDVDR
End Property

Property Let WriteDVDRAM(ByVal bVal As Boolean)
    bWriteDVDRAM = bVal
End Property

Property Get WriteDVDRAM() As Boolean
    WriteDVDRAM = bWriteDVDRAM
End Property

Property Let TestMode(ByVal bVal As Boolean)
    bWriteTestMode = bVal
End Property

Property Get TestMode() As Boolean
    TestMode = bWriteTestMode
End Property

Property Let BURNProof(ByVal bVal As Boolean)
    bBURNProof = bVal
End Property

Property Get BURNProof() As Boolean
    BURNProof = bBURNProof
End Property

Property Let MaxReadSpeed(ByVal lVal As Long)
    lMaxRSpeed = lVal
End Property

Property Get MaxReadSpeed() As Long
    MaxReadSpeed = lMaxRSpeed
End Property

Property Let MaxWriteSpeed(ByVal lVal As Long)
    lMaxWSpeed = lVal
End Property

Property Get MaxWriteSpeed() As Long
    MaxWriteSpeed = lMaxWSpeed
End Property

Property Let CurrReadSpeed(ByVal lVal As Long)
    lCurrRSpeed = lVal
End Property

Property Get CurrReadSpeed() As Long
    CurrReadSpeed = lCurrRSpeed
End Property

Property Let CurrWriteSpeed(ByVal lVal As Long)
    lCurrWSpeed = lVal
End Property

Property Get CurrWriteSpeed() As Long
    CurrWriteSpeed = lCurrWSpeed
End Property

Property Let MultiSession(ByVal bVal As Boolean)
    bMSession = bVal
End Property

Property Get MultiSession() As Boolean
    MultiSession = bMSession
End Property

Property Let Mode2Form1(ByVal bVal As Boolean)
    bMode2Form1 = bVal
End Property

Property Get Mode2Form1() As Boolean
    Mode2Form1 = bMode2Form1
End Property

Property Let Mode2Form2(ByVal bVal As Boolean)
    bMode2Form2 = bVal
End Property

Property Get Mode2Form2() As Boolean
    Mode2Form2 = bMode2Form2
End Property

Property Let BufferSize(ByVal lVal As Long)
    lBufferSize = lVal
End Property

Property Get BufferSize() As Long
    BufferSize = lBufferSize
End Property

Property Let ReadSubChannels(ByVal bVal As Boolean)
    bReadSubs = bVal
End Property

Property Get ReadSubChannels() As Boolean
    ReadSubChannels = bReadSubs
End Property

Property Let ReadSubChannelsCorrected(ByVal bVal As Boolean)
    bReadSubsCorr = bVal
End Property

Property Get ReadSubChannelsCorrected() As Boolean
    ReadSubChannelsCorrected = bReadSubsCorr
End Property

Property Let ReadSubChannelsLeadIn(ByVal bVal As Boolean)
    bReadSubsLeadIn = bVal
End Property

Property Get ReadSubChannelsLeadIn() As Boolean
    ReadSubChannelsLeadIn = bReadSubsLeadIn
End Property

Property Let ReadC2ErrorPointers(ByVal bVal As Boolean)
    bReadC2Pointers = bVal
End Property

Property Get ReadC2ErrorPointers() As Boolean
    ReadC2ErrorPointers = bReadC2Pointers
End Property

Property Let ReadISRC(ByVal bVal As Boolean)
    bReadISRC = bVal
End Property

Property Get ReadISRC() As Boolean
    ReadISRC = bReadISRC
End Property

Property Let ReadUPC(ByVal bVal As Boolean)
    bReadUPC = bVal
End Property

Property Get ReadUPC() As Boolean
    ReadUPC = bReadUPC
End Property

Property Let ReadBarCode(ByVal bVal As Boolean)
    bReadBC = bVal
End Property

Property Get ReadBarCode() As Boolean
    ReadBarCode = bReadBC
End Property

Property Let AnalogAudio(ByVal bVal As Boolean)
    bAnalogAudio = bVal
End Property

Property Get AnalogAudio() As Boolean
    AnalogAudio = bAnalogAudio
End Property

Property Let ReadDASectors(ByVal bVal As Boolean)
    bCDDARawRead = bVal
End Property

Property Get ReadDASectors() As Boolean
    ReadDASectors = bCDDARawRead
End Property

Property Let JitterCorrection(ByVal bVal As Boolean)
    bNoJitter = bVal
End Property

Property Get JitterCorrection() As Boolean
    JitterCorrection = bNoJitter
End Property

Property Let LockMedia(ByVal bVal As Boolean)
    bLockMedia = bVal
End Property

Property Get LockMedia() As Boolean
    LockMedia = bLockMedia
End Property

Property Let LoadingMechanism(ByVal iVal As e_LoadingMechanism)
    iLoadMech = iVal
End Property

Property Get LoadingMechanism() As e_LoadingMechanism
    LoadingMechanism = iLoadMech
End Property

Property Let Interface(ByVal iVal As e_Interfaces)
    iInterface = iVal
End Property

Property Get Interface() As e_Interfaces
    Interface = iInterface
End Property

Property Let WriteModeRaw96(ByVal bVal As Boolean)
    bRaw96 = bVal
End Property

Property Get WriteModeRaw96() As Boolean
    WriteModeRaw96 = bRaw96
End Property

Property Let WriteModeRaw96Test(ByVal bVal As Boolean)
    bRaw96Test = bVal
End Property

Property Get WriteModeRaw96Test() As Boolean
    WriteModeRaw96Test = bRaw96Test
End Property

Property Let WriteModeRaw16(ByVal bVal As Boolean)
    bRaw16 = bVal
End Property

Property Get WriteModeRaw16() As Boolean
    WriteModeRaw16 = bRaw16
End Property

Property Let WriteModeRaw16Test(ByVal bVal As Boolean)
    bRaw16Test = bVal
End Property

Property Get WriteModeRaw16Test() As Boolean
    WriteModeRaw16Test = bRaw16Test
End Property

Property Let WriteModeSao(ByVal bVal As Boolean)
    bSao = bVal
End Property

Property Get WriteModeSao() As Boolean
    WriteModeSao = bSao
End Property

Property Let WriteModeSaoTest(ByVal bVal As Boolean)
    bSaoTest = bVal
End Property

Property Get WriteModeSaoTest() As Boolean
    WriteModeSaoTest = bSaoTest
End Property

Property Let WriteModeTao(ByVal bVal As Boolean)
    bTao = bVal
End Property

Property Get WriteModeTao() As Boolean
    WriteModeTao = bTao
End Property

Property Let WriteModeTaoTest(ByVal bVal As Boolean)
    bTaoTest = bVal
End Property

Property Get WriteModeTaoTest() As Boolean
    WriteModeTaoTest = bTaoTest
End Property
