VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{FE0065C0-1B7B-11CF-9D53-00AA003C9CB6}#1.1#0"; "comct232.ocx"
Begin VB.Form frmSectorsViewer 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Sectors Viewer"
   ClientHeight    =   6090
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9810
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmSectorsViewer.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6090
   ScaleWidth      =   9810
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdGoToSectorLast 
      Caption         =   "Go to last sector"
      Height          =   285
      Left            =   7830
      TabIndex        =   15
      Top             =   4950
      Width           =   1905
   End
   Begin VB.CommandButton cmdGoToSectorFirst 
      Caption         =   "Go to first sector"
      Height          =   285
      Left            =   7830
      TabIndex        =   14
      Top             =   4590
      Width           =   1905
   End
   Begin VB.CommandButton cmdGoToTrackEnd 
      Caption         =   "Go to track's end"
      Height          =   285
      Left            =   7830
      TabIndex        =   13
      Top             =   4050
      Width           =   1905
   End
   Begin VB.CommandButton cmdGoToTrackStart 
      Caption         =   "Go to track's start"
      Height          =   285
      Left            =   7830
      TabIndex        =   12
      Top             =   3690
      Width           =   1905
   End
   Begin VB.ListBox lstTracks 
      Height          =   2790
      Left            =   7830
      TabIndex        =   11
      Top             =   810
      Width           =   1905
   End
   Begin VB.CommandButton cmdSaveSector 
      Caption         =   "Save sector"
      Height          =   285
      Left            =   90
      TabIndex        =   10
      Top             =   60
      Width           =   1635
   End
   Begin VB.TextBox txtSector 
      Height          =   285
      Left            =   2640
      MaxLength       =   6
      TabIndex        =   2
      Text            =   "0"
      ToolTipText     =   "sector to read"
      Top             =   55
      Width           =   1395
   End
   Begin VB.ComboBox cboReadMode 
      Height          =   315
      ItemData        =   "frmSectorsViewer.frx":000C
      Left            =   5520
      List            =   "frmSectorsViewer.frx":001C
      Style           =   2  'Dropdown List
      TabIndex        =   1
      ToolTipText     =   "Parts of a sector to read"
      Top             =   50
      Width           =   2145
   End
   Begin VB.CheckBox chkECCOff 
      Caption         =   "&Deactivate ECC"
      Height          =   195
      Left            =   7830
      TabIndex        =   0
      ToolTipText     =   "Activate/Deactivate Error-Correction"
      Top             =   90
      Width           =   1725
   End
   Begin MSComDlg.CommonDialog dlg 
      Left            =   7110
      Top             =   630
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DialogTitle     =   "Save sector as..."
      Filter          =   "Binary data (*.bin)|*.bin|Data (*.dat)|*.dat|All files (*.*)|*.*"
      Flags           =   2
   End
   Begin ComCtl2.UpDown UpDown 
      Height          =   285
      Left            =   4035
      TabIndex        =   3
      Top             =   60
      Width           =   240
      _ExtentX        =   423
      _ExtentY        =   503
      _Version        =   327681
      BuddyControl    =   "txtSector"
      BuddyDispid     =   196613
      OrigLeft        =   6930
      OrigTop         =   180
      OrigRight       =   7170
      OrigBottom      =   465
      SyncBuddy       =   -1  'True
      BuddyProperty   =   0
      Enabled         =   -1  'True
   End
   Begin MSComctlLib.StatusBar sbar 
      Align           =   2  'Align Bottom
      Height          =   240
      Left            =   0
      TabIndex        =   4
      Top             =   5850
      Width           =   9810
      _ExtentX        =   17304
      _ExtentY        =   423
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   4
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            Object.Width           =   7126
            MinWidth        =   7126
            Text            =   "Drive:"
            TextSave        =   "Drive:"
            Object.ToolTipText     =   "Drive's name"
         EndProperty
         BeginProperty Panel2 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            Text            =   "size"
            TextSave        =   "size"
            Object.ToolTipText     =   "inserted disc's size"
         EndProperty
         BeginProperty Panel3 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            Object.Width           =   3951
            MinWidth        =   3951
            Text            =   "sectors"
            TextSave        =   "sectors"
            Object.ToolTipText     =   "current sector/available sectors"
         EndProperty
         BeginProperty Panel4 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            Object.Width           =   3598
            MinWidth        =   3598
            Text            =   "Sector Mode"
            TextSave        =   "Sector Mode"
            Object.ToolTipText     =   "Mode of the current sector"
         EndProperty
      EndProperty
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin MSComctlLib.ListView lstHex 
      Height          =   5145
      Left            =   0
      TabIndex        =   5
      Top             =   540
      Width           =   7665
      _ExtentX        =   13520
      _ExtentY        =   9075
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   4
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "CD Offset"
         Object.Width           =   2045
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Offset"
         Object.Width           =   1464
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "hexadecimal data"
         Object.Width           =   6068
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Text            =   "binary data"
         Object.Width           =   3246
      EndProperty
   End
   Begin VB.Label lblStat 
      BackStyle       =   0  'Transparent
      Caption         =   "Ready."
      Height          =   195
      Left            =   7845
      TabIndex        =   8
      ToolTipText     =   "status"
      Top             =   5430
      Width           =   1860
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00808080&
      X1              =   0
      X2              =   9810
      Y1              =   5760
      Y2              =   5760
   End
   Begin VB.Line Line2 
      BorderColor     =   &H00FFFFFF&
      X1              =   0
      X2              =   9810
      Y1              =   5775
      Y2              =   5775
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "D&isc Content:"
      Height          =   195
      Left            =   7830
      TabIndex        =   9
      ToolTipText     =   "available tracks on the disc"
      Top             =   540
      Width           =   1170
   End
   Begin VB.Line Line3 
      BorderColor     =   &H00808080&
      X1              =   7830
      X2              =   9720
      Y1              =   4450
      Y2              =   4450
   End
   Begin VB.Line Line4 
      BorderColor     =   &H00FFFFFF&
      X1              =   7830
      X2              =   9720
      Y1              =   4470
      Y2              =   4470
   End
   Begin VB.Shape shpStat 
      BackColor       =   &H0092C4F1&
      BackStyle       =   1  'Opaque
      BorderColor     =   &H008AB1E1&
      Height          =   285
      Left            =   7830
      Top             =   5400
      Width           =   1905
   End
   Begin VB.Line Line5 
      BorderColor     =   &H00808080&
      X1              =   7830
      X2              =   9720
      Y1              =   5310
      Y2              =   5310
   End
   Begin VB.Line Line6 
      BorderColor     =   &H00FFFFFF&
      X1              =   7830
      X2              =   9720
      Y1              =   5325
      Y2              =   5325
   End
   Begin VB.Line Line7 
      BorderColor     =   &H00FFFFFF&
      X1              =   0
      X2              =   9810
      Y1              =   465
      Y2              =   465
   End
   Begin VB.Line Line8 
      BorderColor     =   &H00808080&
      X1              =   0
      X2              =   9810
      Y1              =   450
      Y2              =   450
   End
   Begin VB.Label lblSector 
      AutoSize        =   -1  'True
      Caption         =   "se&ctor:"
      Height          =   195
      Left            =   1980
      TabIndex        =   7
      Top             =   90
      Width           =   600
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "&Read-Mode:"
      Height          =   195
      Left            =   4410
      TabIndex        =   6
      Top             =   90
      Width           =   1035
   End
End
Attribute VB_Name = "frmSectorsViewer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public DrvID As String
Dim TOC As t_STOC_STRUCT
Dim bSet As Boolean
Dim SavedBuffer() As Byte
Dim loaded As Boolean

Public Sub ShowEx(ByVal trk As Byte)
    lstTracks.ListIndex = trk - 1
    Call lstTracks_DblClick
    Me.Show vbModal, frmMain
End Sub

Private Sub cboReadMode_Click()
    'mode changed, read the sector a second time
    If loaded Then ReadSector txtSector
End Sub

Private Sub chkECCOff_Click()
    '(de)activate the error correction to read damaged sectors
    'isn't supported by every drive

    If chkECCOff.value = 1 Then
        If Not bSet Then
            If Not DeactivateECC(DrvID) Then
                MsgBox "Couldn't deactivate ECC.", vbExclamation, "Error"
                bSet = True
                chkECCOff.value = 0
                Exit Sub
            End If
        Else
            bSet = False
            Exit Sub
        End If
    Else
        If Not bSet Then
            If Not ActivateECC(DrvID) Then
                MsgBox "Couldn't activate ECC.", vbExclamation, "Error"
                bSet = True
                chkECCOff.value = 1
                Exit Sub
            End If
        Else
            bSet = False
            Exit Sub
        End If
    End If
End Sub

Private Sub cmdGoToSectorFirst_Click()
    'jump to the first readable sector on the disc
    With TOC.TocTrack(0)
        txtSector = MSF2LBA(.addr(1), .addr(2), .addr(3))
    End With
    If loaded Then ReadSector txtSector
End Sub

Private Sub cmdGoToSectorLast_Click()
    'jump to the last sector
    With TOC.TocTrack(TOC.LastTrack)
        txtSector = MSF2LBA(.addr(1), .addr(2), .addr(3)) - 1
    End With
    If loaded Then ReadSector txtSector
End Sub

Private Sub cmdGoToTrackEnd_Click()
    'go to the last sector of the current track
    With TOC.TocTrack(lstTracks.ListIndex + 1)
        txtSector = MSF2LBA(.addr(1), .addr(2), .addr(3)) - 1
    End With
    If loaded Then ReadSector txtSector
End Sub

Private Sub cmdGoToTrackStart_Click()
    'go to the first sector of the current track
    With TOC.TocTrack(lstTracks.ListIndex)
        txtSector = MSF2LBA(.addr(1), .addr(2), .addr(3))
    End With
    If loaded Then ReadSector txtSector
End Sub

'save the current sector to a file
Private Sub cmdSaveSector_Click()
    On Error GoTo ErrHndl
    Dim FF As Integer: FF = FreeFile

    dlg.FileName = vbNullString
    dlg.ShowSave
    If dlg.FileName <> vbNullString Then
        Open dlg.FileName For Binary As FF
            'write the buffer to the file
            Put FF, , SavedBuffer
        Close FF
        MsgBox "Saved.", vbInformation, "Saved."
    End If
    Exit Sub

ErrHndl:
    'something went the wrong way...
    MsgBox "Error while saving.", vbExclamation, "Error"
End Sub

Private Sub cmdUnload_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    Dim i As Integer

    DoEvents

    'disc present?
    If IsDiscPresent(DrvID) < 1 Then
        MsgBox "No disc present.", vbExclamation, "Error"
        Unload Me
        Exit Sub
    End If

    'read the TOC
    If Not ReadTOC(DrvID, 0, True, 0, VarPtr(TOC), Len(TOC)) Then
        MsgBox "Couldn't read TOC.", vbExclamation, "Error"
        Unload Me
        Exit Sub
    End If

    'set upper LBA limit
    With TOC.TocTrack(TOC.LastTrack)
        UpDown.max = MSF2LBA(.addr(1), .addr(2), .addr(3)) - 1
    End With

    cboReadMode.ListIndex = 1

    'enumerate tracks
    For i = 0 To TOC.LastTrack - 1
        lstTracks.AddItem "Track " & format(TOC.TocTrack(i).Track, "00")
    Next
    lstTracks.ListIndex = 0

    sbar.Panels(1).Text = frmMain.cboDrvs.List(frmMain.cboDrvs.ListIndex)
    sbar.Panels(2).Text = FormatFileSize(UpDown.max * 2352)
    sbar.Panels(3).Text = txtSector & "/" & UpDown.max & " LBA"
    sbar.Panels(4).Text = SectorMode2Str(GetSectorMode(DrvID, txtSector))

    DoEvents

    loaded = True
    ReadSector 0
End Sub

Private Sub ReadSector(ByVal lSector As Long)
    Dim BufRaw(2351) As Byte, BufRaw96(2447) As Byte
    Dim UserData() As Byte, SectorMode As Long
    Dim i As Long

    lblStat = "Reading sector..."
    cmdSaveSector.Enabled = False

    'get the sector mode
    SectorMode = GetSectorMode(DrvID, lSector)
    If SectorMode = -1 Then
        MsgBox "Couldn't read sector " & txtSector & ".", vbExclamation, "Error"
        lstHex.ListItems.Clear
        lstHex.ListItems.Add , , "failed."
        lblStat = "Failed."
        Exit Sub
    End If

    Select Case cboReadMode.ListIndex
        Case 0
            'USERDATA
            If Not ReadCD(DrvID, lSector, 1, VarPtr(BufRaw(0)), UBound(BufRaw), &HF8) Then
                MsgBox "Couldn't read sector " & lSector & ".", vbExclamation, "Error"
                lblStat = "Failed."
                Exit Sub
            End If

            Select Case SectorMode

                'AUDIO Sector
                Case MODE_AUDIO
                    ReDim UserData(2351)
                    For i = 0 To UBound(UserData)
                        UserData(i) = BufRaw(i)
                    Next i

                'MODE1 Sector (2048 bytes userdata)
                Case MODE_MODE1
                    ReDim UserData(2047)
                    For i = 0 To UBound(UserData)
                        UserData(i) = BufRaw(i + 16)
                    Next i

                'Plain MODE2 or MODE0 sector (2336 bytes userdata)
                Case MODE_MODE2         ' or Mode 0
                    ReDim UserData(2335)
                    For i = 0 To UBound(UserData)
                        UserData(i) = BufRaw(i + 16)
                    Next i

                'MODE2 FORM1 sector (2048 bytes userdata)
                Case MODE_MODE2_FORM1
                    ReDim UserData(2047)
                    For i = 0 To UBound(UserData)
                        UserData(i) = BufRaw(i + 24)
                    Next i

                'MODE2 FORM2 sector ( 2324 bytes userdata)
                Case MODE_MODE2_FORM2
                    ReDim UserData(2323)
                    For i = 0 To UBound(UserData)
                        UserData(i) = BufRaw(i + 24)
                    Next i

            End Select

            'render data to the listview
            RenderData UserData

            'save userdata to a buffer for later saving to a file
            ReDim SavedBuffer(UBound(UserData))
            For i = 0 To UBound(UserData)
                SavedBuffer(i) = UserData(i)
            Next i

        Case 1
            'RAW
            If Not ReadCD(DrvID, lSector, 1, VarPtr(BufRaw(0)), UBound(BufRaw), &HF8) Then
                MsgBox "Couldn't read sector " & lSector & ".", vbExclamation, "Error"
                lblStat = "Failed."
                Exit Sub
            End If
            'render data to the listview
            RenderData BufRaw

            'save raw sector to a buffer for later saving to a file
            ReDim SavedBuffer(UBound(BufRaw))
            For i = 0 To UBound(BufRaw)
                SavedBuffer(i) = BufRaw(i)
            Next i

        Case Else
            'RAW+96/RAW+96 De-Interleaved
            If Not ReadCD(DrvID, lSector, 1, VarPtr(BufRaw96(0)), UBound(BufRaw96), &HF8, IIf(cboReadMode.ListIndex = 2, RCD_SUBCH_PW_RAW, RCD_SUBCH_PW_CORRECTED)) Then
                MsgBox "Couldn't read sector " & lSector & ".", vbExclamation, "Error"
                lblStat = "Failed."
                Exit Sub
            End If
            'render data to the listview
            RenderData BufRaw96

            'save raw sector to a buffer for later saving to a file
            ReDim SavedBuffer(UBound(BufRaw96))
            For i = 0 To UBound(BufRaw96)
                SavedBuffer(i) = BufRaw96(i)
            Next i

    End Select

    'update the panels
    cmdSaveSector.Enabled = True
    sbar.Panels(4) = SectorMode2Str(SectorMode)
    sbar.Panels(3) = txtSector & "/" & UpDown.max & " LBA"

    lblStat = "Ready."
End Sub

'renders a byte array to the listview
Private Sub RenderData(ByRef ByteArr() As Byte)
    Dim i As Long, q As Long, k As Long
    Dim sBin As String, sHex As String
    Const Steps As Integer = 14

    lstHex.ListItems.Clear

    For i = 0 To UBound(ByteArr) Step Steps

        'check if we run into an "index out of bounds"
        If (i + Steps) > UBound(ByteArr) Then

            'generate the binary view for the current line
            sBin = vbNullString
            For k = i To UBound(ByteArr)
                sBin = sBin & Chr(ByteArr(k))
            Next k
            With lstHex.ListItems
                .Add , , format((i + 1) + (txtSector * 2352), "000000000")
                .Item(.Count).SubItems(1) = format(i + 1, "0000")
                .Item(.Count).SubItems(3) = ParseBin(sBin)
            End With

            'generate the hexadecimal view for the current line
            sHex = vbNullString
            For q = 1 To Len(sBin)
                sHex = sHex & FormatEx(Hex(Asc(Mid$(sBin, q, 1))))
            Next q
            lstHex.ListItems(lstHex.ListItems.Count).SubItems(2) = sHex

            Exit Sub
        End If

        'generate the binary view for the current line
        sBin = vbNullString
        For k = i To (i + Steps)
            sBin = sBin & Chr(ByteArr(k))
        Next k
        With lstHex.ListItems
                .Add , , format((i + 1) + (txtSector * 2352), "000000000")
                .Item(.Count).SubItems(1) = format(i + 1, "0000")
                .Item(.Count).SubItems(3) = ParseBin(sBin)
        End With

        'generate the hexadecimal view for the current line
        sHex = vbNullString
        For q = 1 To Len(sBin)
            sHex = sHex & FormatEx(Hex(Asc(Mid$(sBin, q, 1))))
        Next q
        lstHex.ListItems(lstHex.ListItems.Count).SubItems(2) = sHex
    Next i
End Sub

'format a hex value
Private Function FormatEx(num As String) As String
    num = format(num, "00")
    If Len(CStr(num)) = 1 Then FormatEx = "0" & num Else: FormatEx = num
End Function

'replace non-visible characters with dots
Private Function ParseBin(ByVal sBin As String) As String
    Const ChrMap As String = "AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz0123456789!""""$%&/()=?,.-;:_<>|"
    Dim sBuf As String, i As Long

    For i = 1 To Len(sBin)
        If InStr(1, ChrMap, Mid$(sBin, i, 1)) > 1 Then
            sBuf = sBuf & Mid$(sBin, i, 1)
        ElseIf Mid$(sBin, i, 1) = " " Then
            sBuf = sBuf & " "
        Else
            sBuf = sBuf & "."
        End If
    Next i

    ParseBin = sBuf
End Function

Private Sub lstTracks_DblClick()
    Call cmdGoToTrackStart_Click
End Sub

Private Sub txtSector_Change()
    CheckText
End Sub

'only numeric values for txtSector
Private Sub CheckText()
    Const ChrMap = "1234567890"         'allowed keys
    Dim i As Byte, sBuf As String
    Dim SelStart As Byte
    SelStart = txtSector.SelStart
    For i = 1 To Len(txtSector)
        If InStr(1, ChrMap, Mid(txtSector, i, 1)) > 0 Then sBuf = sBuf & Mid(txtSector, i, 1)
    Next
    txtSector = sBuf
    txtSector.SelStart = SelStart
End Sub

Private Sub txtSector_KeyUp(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyReturn Then
        If txtSector.Text > UpDown.max Then txtSector = UpDown.max
        If loaded Then ReadSector txtSector
    End If
End Sub

Private Sub txtSector_LostFocus()
    If txtSector.Text > UpDown.max Then txtSector = UpDown.max
    If loaded Then ReadSector txtSector
End Sub

Private Sub UpDown_DownClick()
    If loaded Then ReadSector txtSector
End Sub

Private Sub UpDown_UpClick()
    If loaded Then ReadSector txtSector
End Sub
