VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmTrkNfo 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Track-Info (+Grabber)"
   ClientHeight    =   2865
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6735
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmTrkNfo.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2865
   ScaleWidth      =   6735
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdVSectors 
      Caption         =   "Switch to sectors viewer"
      Height          =   285
      Left            =   2070
      TabIndex        =   3
      Top             =   2520
      Width           =   2265
   End
   Begin MSComDlg.CommonDialog dlg 
      Left            =   6030
      Top             =   270
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      Flags           =   2
   End
   Begin VB.CommandButton cmdGrab 
      Caption         =   "Grab selected item"
      Height          =   285
      Left            =   90
      TabIndex        =   2
      Top             =   2520
      Width           =   1905
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   285
      Left            =   5220
      TabIndex        =   1
      Top             =   2520
      Width           =   1365
   End
   Begin MSComctlLib.TreeView tvwTrks 
      Height          =   2175
      Left            =   90
      TabIndex        =   0
      Top             =   270
      Width           =   6495
      _ExtentX        =   11456
      _ExtentY        =   3836
      _Version        =   393217
      HideSelection   =   0   'False
      Indentation     =   294
      LabelEdit       =   1
      LineStyle       =   1
      Style           =   6
      Appearance      =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
End
Attribute VB_Name = "frmTrkNfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public DrvID As String
Private WithEvents grabber As cGrab
Attribute grabber.VB_VarHelpID = -1

Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub cmdGrab_Click()
    Dim trknfo As cTrackInfo

    'session selected?
    If Left$(tvwTrks.SelectedItem.Key, 4) = "sess" Then

        dlg.Filter = "Bin Images (*.bin)|*.bin"
        dlg.FileName = vbNullString
        dlg.ShowSave
        If Not dlg.FileName = vbNullString Then

            Me.Hide
            frmMain.Hide
            frmSimpleProgress.Show
            Select Case grabber.SaveBinCue(DrvID, dlg.FileName, Right(tvwTrks.SelectedItem.Key, 2))
                Case -6
                    MsgBox "No disc present.", vbExclamation, "Error"
                Case -5
                    MsgBox "Drive not ready.", vbExclamation, "Error"
                Case -4
                    MsgBox "Disc is empty.", vbExclamation, "Error"
                Case -2
                    MsgBox "Couldn't read Sub-Channels.", vbExclamation, "Error"
                Case -1
                    MsgBox "Readerror.", vbExclamation, "Error"
                Case 1
                    MsgBox "Finished.", vbInformation, "Ok"
            End Select
            Unload frmSimpleProgress
            frmMain.Show
            Me.Show vbModal, frmMain

        End If

    'track selected?
    ElseIf Left$(tvwTrks.SelectedItem.Key, 5) = "track" Then

        Set trknfo = TrackInfo(DrvID, Right(tvwTrks.SelectedItem.Key, 2))
        If trknfo.DataMode = MODE_MODE2 Or trknfo.DataMode = MODE_MODE2_FORM1 Or trknfo.DataMode = MODE_MODE2_FORM2 Then
            MsgBox "Mode 2 tracks are not supported." & vbCrLf & _
                   "Try to save the whole session.", vbExclamation, "Error"
            Exit Sub
        End If

        If IsAudioTrack(DrvID, Right(tvwTrks.SelectedItem.Key, 2)) Then
            dlg.Filter = "Wave files (*.wav)|*.wav"
        Else
            dlg.Filter = "ISO Images (*.iso)|*.iso"
        End If
        dlg.FileName = vbNullString
        dlg.ShowSave

        If Not dlg.FileName = vbNullString Then

            Me.Hide
            frmMain.Hide
            frmSimpleProgress.Show

            If LCase$(Right$(dlg.FileName, 3)) = "wav" Then

                Select Case grabber.SaveAudioTrack(DrvID, Right(tvwTrks.SelectedItem.Key, 2), dlg.FileName)
                    Case -1
                        MsgBox "Unknown error", vbExclamation, "Error"
                    Case 0
                        MsgBox "Readerror", vbExclamation, "Error"
                    Case 1
                        MsgBox "Finished.", vbInformation, "Ok"
                End Select

            ElseIf LCase$(Right$(dlg.FileName, 3)) = "iso" Then

                Select Case grabber.SaveDataTrack(DrvID, Right(tvwTrks.SelectedItem.Key, 2), dlg.FileName)
                    Case -1
                        MsgBox "Unknown error", vbExclamation, "Error"
                    Case 0
                        MsgBox "Readerror", vbExclamation, "Error"
                    Case 1
                        MsgBox "Finished.", vbInformation, "Ok"
                End Select

            End If

            Unload frmSimpleProgress
            frmMain.Show
            Me.Show vbModal, frmMain

        End If

    'track info selected?
    ElseIf Left$(tvwTrks.SelectedItem.Parent.Key, 5) = "track" Then

        Set trknfo = TrackInfo(DrvID, Right(tvwTrks.SelectedItem.Parent.Key, 2))
        If trknfo.DataMode = MODE_MODE2 Or trknfo.DataMode = MODE_MODE2_FORM1 Or trknfo.DataMode = MODE_MODE2_FORM2 Then
            MsgBox "Mode 2 tracks are not supported." & vbCrLf & _
                   "Try to save the whole session.", vbExclamation, "Error"
            Exit Sub
        End If

        If IsAudioTrack(DrvID, Right(tvwTrks.SelectedItem.Parent.Key, 2)) Then
            dlg.Filter = "Wave files (*.wav)|*.wav"
        Else
            dlg.Filter = "ISO Images (*.iso)|*.iso"
        End If
        dlg.FileName = vbNullString
        dlg.ShowSave
        If Not dlg.FileName = vbNullString Then

            Me.Hide
            frmMain.Hide
            frmSimpleProgress.Show

            If LCase$(Right$(dlg.FileName, 3)) = "wav" Then

                Select Case grabber.SaveAudioTrack(DrvID, Right(tvwTrks.SelectedItem.Parent.Key, 2), dlg.FileName)
                    Case -1
                        MsgBox "Unknown error", vbExclamation, "Error"
                    Case 0
                        MsgBox "Readerror", vbExclamation, "Error"
                    Case 1
                        MsgBox "Finished.", vbInformation, "Ok"
                End Select

            ElseIf LCase$(Right$(dlg.FileName, 3)) = "iso" Then

                Select Case grabber.SaveDataTrack(DrvID, Right(tvwTrks.SelectedItem.Parent.Key, 2), dlg.FileName)
                    Case -1
                        MsgBox "Unknown error", vbExclamation, "Error"
                    Case 0
                        MsgBox "Readerror", vbExclamation, "Error"
                    Case 1
                        MsgBox "Finished.", vbInformation, "Ok"
                End Select

            End If

            Unload frmSimpleProgress
            frmMain.Show
            Me.Show vbModal, frmMain

        End If

    End If
End Sub

Private Sub cmdVSectors_Click()
    Dim sessnfo As cSessInfo

    frmSectorsViewer.DrvID = DrvID
    
    'session selected?
    If Left$(tvwTrks.SelectedItem.Key, 4) = "sess" Then

        Set sessnfo = SessionInfo(DrvID, Right(tvwTrks.SelectedItem.Key, 2))
        Me.Hide
        frmSectorsViewer.ShowEx sessnfo.FirstTrack
        Unload Me

    'track selected?
    ElseIf Left$(tvwTrks.SelectedItem.Key, 5) = "track" Then

        Me.Hide
        frmSectorsViewer.ShowEx Right(tvwTrks.SelectedItem.Key, 2)
        Unload Me

    'track info selected?
    ElseIf Left$(tvwTrks.SelectedItem.Parent.Key, 5) = "track" Then

        Me.Hide
        frmSectorsViewer.ShowEx Right(tvwTrks.SelectedItem.Parent.Key, 2)
        Unload Me

    End If
End Sub

Private Sub Form_Load()
    Set grabber = New cGrab
End Sub

Private Sub grabber_ReadProgress(ByVal percent As Long, ByVal CurrTrk As Integer)
    frmSimpleProgress.SetPrgMax 100
    frmSimpleProgress.SetPrgVal percent
    frmSimpleProgress.SetStatus "Reading track " & CurrTrk & " (" & percent & "%)"
End Sub
