VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cDrives"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private cCol As Collection

Public Function Add(Optional ByVal DriveID As String, Optional ByVal DriveVendor As String, _
                    Optional ByVal DriveName As String, Optional ByVal DriveRevision As String, _
                    Optional ByVal HA As Integer, Optional ByVal ID As Integer, _
                    Optional ByVal DriveChr As String, Optional DrvNfo As cDriveInfo)

  Dim objNewMember As cDrive
  Set objNewMember = New cDrive

  With objNewMember
    .DriveID = DriveID
    .DrvChr = DriveChr
    .Vendor = DriveVendor
    .Product = DriveName
    .Revision = DriveRevision
    .HostAdapter = HA
    .Target = ID
    .Info = DrvNfo
  End With

  cCol.Add objNewMember
  Set objNewMember = Nothing
  Set DrvNfo = Nothing
End Function

Public Property Get Item(ByVal Index As Long) As cDrive
  Set Item = cCol(Index)
End Property

Public Property Get Count() As Long
  Count = cCol.Count
End Property

Public Sub Remove(ByVal Index As Integer)
  cCol.Remove Index
End Sub

Private Sub Class_Initialize()
  Set cCol = New Collection
End Sub

Private Sub Class_Terminate()
  Set cCol = Nothing
End Sub
