VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmReadISO 
   Caption         =   "ISO Reader"
   ClientHeight    =   6915
   ClientLeft      =   60
   ClientTop       =   525
   ClientWidth     =   10740
   ControlBox      =   0   'False
   Icon            =   "frmReadISO.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   6915
   ScaleWidth      =   10740
   WindowState     =   2  'Maximized
   Begin MSComDlg.CommonDialog dlgSave 
      Left            =   630
      Top             =   6300
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      Flags           =   2
   End
   Begin MSComctlLib.ImageList img 
      Left            =   0
      Top             =   6300
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   3
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmReadISO.frx":000C
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmReadISO.frx":05A6
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmReadISO.frx":0B50
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin Flamed_2.ctlSplitter spltLeft 
      Height          =   6315
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   10455
      _ExtentX        =   18441
      _ExtentY        =   11139
      SplitterPos     =   10418
      RatioFromTop    =   1
      Child1          =   "tvwDirs"
      Child2          =   "spltRight"
      LiveUpdate      =   0   'False
      Begin Flamed_2.ctlSplitter spltRight 
         Height          =   6315
         Left            =   10200
         TabIndex        =   2
         Top             =   0
         Width           =   255
         _ExtentX        =   450
         _ExtentY        =   11139
         SplitterPos     =   218
         RatioFromTop    =   1
         Child1          =   "lvwFiles"
         Child2          =   "lstInfo"
         LiveUpdate      =   0   'False
         Begin VB.ListBox lstInfo 
            Height          =   6300
            Left            =   330
            TabIndex        =   4
            Top             =   0
            Width           =   255
         End
         Begin MSComctlLib.ListView lvwFiles 
            Height          =   6345
            Left            =   -15
            TabIndex        =   3
            Top             =   -15
            Width           =   285
            _ExtentX        =   503
            _ExtentY        =   11192
            View            =   3
            LabelEdit       =   1
            LabelWrap       =   -1  'True
            HideSelection   =   -1  'True
            FullRowSelect   =   -1  'True
            _Version        =   393217
            SmallIcons      =   "img"
            ForeColor       =   -2147483640
            BackColor       =   -2147483643
            BorderStyle     =   1
            Appearance      =   1
            NumItems        =   3
            BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
               Text            =   "filename"
               Object.Width           =   4057
            EndProperty
            BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
               SubItemIndex    =   1
               Text            =   "size"
               Object.Width           =   2117
            EndProperty
            BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
               SubItemIndex    =   2
               Text            =   "Date"
               Object.Width           =   3246
            EndProperty
         End
      End
      Begin MSComctlLib.TreeView tvwDirs 
         Height          =   6315
         Left            =   0
         TabIndex        =   1
         Top             =   0
         Width           =   10125
         _ExtentX        =   17859
         _ExtentY        =   11139
         _Version        =   393217
         HideSelection   =   0   'False
         Indentation     =   471
         LabelEdit       =   1
         LineStyle       =   1
         Style           =   7
         ImageList       =   "img"
         Appearance      =   1
      End
   End
End
Attribute VB_Name = "frmReadISO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim iso As New cISO9660Read

Private Sub Form_Load()
    Set CurrPrj = Me
    tvwDirs.Nodes.Add , , "\", "\", 2
    spltLeft.RatioFromTop = 0.2
    spltRight.RatioFromTop = 0.7
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    spltLeft.Height = Me.ScaleHeight
    spltLeft.Width = Me.ScaleWidth
End Sub

Public Sub ExtractFile()
    On Error GoTo ErrH
    dlgSave.Filter = lvwFiles.SelectedItem.Text & "|" & lvwFiles.SelectedItem.Text
    dlgSave.FileName = lvwFiles.SelectedItem.Text
    dlgSave.ShowSave

    'Save the selected file
    iso.ReadFileToFile tvwDirs.SelectedItem.Key & lvwFiles.SelectedItem.Text, dlgSave.FileName
ErrH:
End Sub

Public Sub OpenFile(ByVal sPath As String)
    On Error Resume Next

    'parse ISO
    If Not iso.ReadISO(sPath) Then
        MsgBox "Couldn't read " & sPath, vbExclamation, "Error"
        Exit Sub
    End If

    'prepare to add directory structure
    tvwDirs.Nodes.Clear
    lvwFiles.ListItems.Clear
    tvwDirs.Nodes.Add , , "\", "\", 2

    With lstInfo
        .Clear
        .AddItem "Volume ID: " & iso.VolumeID
        .AddItem "System ID: " & iso.SystemID
        .AddItem "Volume Size: " & FormatFileSize(iso.VolumeSize * 2048)
        .AddItem "Application: " & iso.ApplicationID
        .AddItem "Data Preparer: " & iso.DataPreparerID
        .AddItem "Publisher: " & iso.PublisherID
        .AddItem "Abstract file: " & iso.AbstractFile
        .AddItem "Bibliographic file: " & iso.BibliographicFile
        .AddItem "Copyright file: " & iso.CopyrightFile
        .AddItem "Creation Date: " & iso.VolumeCreationDate
        .AddItem "Effective Date: " & iso.VolumeEffectiveDate
        .AddItem "Expiration Date: " & iso.VolumeExpirationDate
        .AddItem "Modification Date: " & iso.VolumeModificationDate
    End With

    'add directories
    ParseDir "\"
End Sub

Private Sub ParseDir(ByVal sPath As String)
    Dim dirs() As String
    Dim i As Integer

    'add all sub-directories of sPath
    If iso.HasSubDirs(sPath) Then
        dirs = iso.GetSubDirs(sPath)
        For i = 0 To UBound(dirs)
            tvwDirs.Nodes.Add iso.GetUpperDir(dirs(i)), tvwChild, dirs(i), iso.GetDirname(dirs(i)), 1
            ParseDir dirs(i)
        Next
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set CurrPrj = Nothing
End Sub

Private Sub lvwFiles_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = 2 Then PopupMenu frmMain.mnuISO
End Sub

Private Sub tvwDirs_Click()
    Dim files() As String
    Dim i As Integer

    If iso.CurrentISO = vbNullString Then Exit Sub

    'add all files of the current selected directory
    lvwFiles.ListItems.Clear
    If iso.HasSubFiles(tvwDirs.SelectedItem.Key) Then
        files = iso.GetSubFiles(tvwDirs.SelectedItem.Key)
        For i = 0 To UBound(files)
            With lvwFiles.ListItems.Add(, , files(i), , 3)
                .SubItems(1) = FormatFileSize(iso.GetFilesize(tvwDirs.SelectedItem.Key & files(i)))
                .SubItems(2) = iso.GetFileDate(tvwDirs.SelectedItem.Key & files(i))
            End With
        Next
    End If
End Sub
